<?php
/* Autor...:  */
/* Esquema.: MST_ListaPrecioDetalle.xml */
/* Generado: 2021-12-19 18:48:56 */

/* Metodos de acceso a los campos de la tabla MST_ListaPrecioDetalle */
abstract class BaseMST_ListaPrecioDetalleBN
{
    /* Campos de la tabla */
    private $i_IdListaPreciDet;    // IdListaPreciDet: ( no definido )
    private $i_IdListaPreciCab;    // IdListaPreciCab: ( no definido )
    private $i_IdCompania;    // IdCompania: ( no definido )
    private $i_IdSucursal;    // IdSucursal: ( no definido )
    private $s_IdItem;    // IdItem: ( no definido )
    private $i_IdTipoLista;    // IdTipoLista: ( no definido )
    private $i_IdRango;    // IdRango: ( no definido )
    private $i_IdRangoDetalle;    // IdRangoDetalle: ( no definido )
    private $s_IdTipoPrecio;    // IdTipoPrecio: ( no definido )
    private $d_FechaInicio;    // FechaInicio: ( no definido )
    private $d_FechaFin;    // FechaFin: ( no definido )
    private $s_Estado;    // Estado: ( no definido )
    private $f_PrecioCosto;    // PrecioCosto: ( no definido )
    private $f_PrecioCostoIGV;    // PrecioCostoIGV: ( no definido )
    private $f_PorcentajeUtilidad;    // PorcentajeUtilidad: ( no definido )
    private $i_AfectoIGV;    // AfectoIGV: ( no definido )
    private $f_PrecioVenta;    // PrecioVenta: ( no definido )
    private $f_MontoIGV;    // MontoIGV: ( no definido )
    private $f_PrecioVentaIGV;    // PrecioVentaIGV: ( no definido )
    private $f_MontoDescuento;    // MontoDescuento: ( no definido )
    private $f_PorcentajeDescuento;    // PorcentajeDescuento: ( no definido )
    private $s_DescuentoFlag;    // DescuentoFlag: ( no definido )
    private $d_FechaCreacion;    // FechaCreacion: ( no definido )
    private $s_UsuarioCreacion;    // UsuarioCreacion: ( no definido )
    private $d_FechaModificacion;    // FechaModificacion: ( no definido )
    private $s_UsuarioModificacion;    // UsuarioModificacion: ( no definido )

    /* Establece el valor del campo IdListaPreciDet */
    public function setIdListaPreciDet( $i_IdListaPreciDet )
    {
        $this->i_IdListaPreciDet = $i_IdListaPreciDet;
    }

    /* Obtiene el valor del campo IdListaPreciDet */
    public function getIdListaPreciDet()
    {
        return $this->i_IdListaPreciDet;
    }

    /* Establece el valor del campo IdListaPreciCab */
    public function setIdListaPreciCab( $i_IdListaPreciCab )
    {
        $this->i_IdListaPreciCab = $i_IdListaPreciCab;
    }

    /* Obtiene el valor del campo IdListaPreciCab */
    public function getIdListaPreciCab()
    {
        return $this->i_IdListaPreciCab;
    }

    /* Establece el valor del campo IdCompania */
    public function setIdCompania( $i_IdCompania )
    {
        $this->i_IdCompania = $i_IdCompania;
    }

    /* Obtiene el valor del campo IdCompania */
    public function getIdCompania()
    {
        return $this->i_IdCompania;
    }

    /* Establece el valor del campo IdSucursal */
    public function setIdSucursal( $i_IdSucursal )
    {
        $this->i_IdSucursal = $i_IdSucursal;
    }

    /* Obtiene el valor del campo IdSucursal */
    public function getIdSucursal()
    {
        return $this->i_IdSucursal;
    }

    /* Establece el valor del campo IdItem */
    public function setIdItem( $s_IdItem )
    {
        $this->s_IdItem = $s_IdItem;
    }

    /* Obtiene el valor del campo IdItem */
    public function getIdItem()
    {
        return $this->s_IdItem;
    }

    /* Establece el valor del campo IdTipoLista */
    public function setIdTipoLista( $i_IdTipoLista )
    {
        $this->i_IdTipoLista = $i_IdTipoLista;
    }

    /* Obtiene el valor del campo IdTipoLista */
    public function getIdTipoLista()
    {
        return $this->i_IdTipoLista;
    }

    /* Establece el valor del campo IdRango */
    public function setIdRango( $i_IdRango )
    {
        $this->i_IdRango = $i_IdRango;
    }

    /* Obtiene el valor del campo IdRango */
    public function getIdRango()
    {
        return $this->i_IdRango;
    }

    /* Establece el valor del campo IdRangoDetalle */
    public function setIdRangoDetalle( $i_IdRangoDetalle )
    {
        $this->i_IdRangoDetalle = $i_IdRangoDetalle;
    }

    /* Obtiene el valor del campo IdRangoDetalle */
    public function getIdRangoDetalle()
    {
        return $this->i_IdRangoDetalle;
    }

    /* Establece el valor del campo IdTipoPrecio */
    public function setIdTipoPrecio( $s_IdTipoPrecio )
    {
        $this->s_IdTipoPrecio = $s_IdTipoPrecio;
    }

    /* Obtiene el valor del campo IdTipoPrecio */
    public function getIdTipoPrecio()
    {
        return $this->s_IdTipoPrecio;
    }

    /* Establece el valor del campo FechaInicio */
    public function setFechaInicio( $d_FechaInicio )
    {
        $this->d_FechaInicio = $d_FechaInicio;
    }

    /* Obtiene el valor del campo FechaInicio */
    public function getFechaInicio()
    {
        return $this->d_FechaInicio;
    }

    /* Establece el valor del campo FechaFin */
    public function setFechaFin( $d_FechaFin )
    {
        $this->d_FechaFin = $d_FechaFin;
    }

    /* Obtiene el valor del campo FechaFin */
    public function getFechaFin()
    {
        return $this->d_FechaFin;
    }

    /* Establece el valor del campo Estado */
    public function setEstado( $s_Estado )
    {
        $this->s_Estado = $s_Estado;
    }

    /* Obtiene el valor del campo Estado */
    public function getEstado()
    {
        return $this->s_Estado;
    }

    /* Establece el valor del campo PrecioCosto */
    public function setPrecioCosto( $f_PrecioCosto )
    {
        $this->f_PrecioCosto = $f_PrecioCosto;
    }

    /* Obtiene el valor del campo PrecioCosto */
    public function getPrecioCosto()
    {
        return $this->f_PrecioCosto;
    }

    /* Establece el valor del campo PrecioCostoIGV */
    public function setPrecioCostoIGV( $f_PrecioCostoIGV )
    {
        $this->f_PrecioCostoIGV = $f_PrecioCostoIGV;
    }

    /* Obtiene el valor del campo PrecioCostoIGV */
    public function getPrecioCostoIGV()
    {
        return $this->f_PrecioCostoIGV;
    }

    /* Establece el valor del campo PorcentajeUtilidad */
    public function setPorcentajeUtilidad( $f_PorcentajeUtilidad )
    {
        $this->f_PorcentajeUtilidad = $f_PorcentajeUtilidad;
    }

    /* Obtiene el valor del campo PorcentajeUtilidad */
    public function getPorcentajeUtilidad()
    {
        return $this->f_PorcentajeUtilidad;
    }

    /* Establece el valor del campo AfectoIGV */
    public function setAfectoIGV( $i_AfectoIGV )
    {
        $this->i_AfectoIGV = $i_AfectoIGV;
    }

    /* Obtiene el valor del campo AfectoIGV */
    public function getAfectoIGV()
    {
        return $this->i_AfectoIGV;
    }

    /* Establece el valor del campo PrecioVenta */
    public function setPrecioVenta( $f_PrecioVenta )
    {
        $this->f_PrecioVenta = $f_PrecioVenta;
    }

    /* Obtiene el valor del campo PrecioVenta */
    public function getPrecioVenta()
    {
        return $this->f_PrecioVenta;
    }

    /* Establece el valor del campo MontoIGV */
    public function setMontoIGV( $f_MontoIGV )
    {
        $this->f_MontoIGV = $f_MontoIGV;
    }

    /* Obtiene el valor del campo MontoIGV */
    public function getMontoIGV()
    {
        return $this->f_MontoIGV;
    }

    /* Establece el valor del campo PrecioVentaIGV */
    public function setPrecioVentaIGV( $f_PrecioVentaIGV )
    {
        $this->f_PrecioVentaIGV = $f_PrecioVentaIGV;
    }

    /* Obtiene el valor del campo PrecioVentaIGV */
    public function getPrecioVentaIGV()
    {
        return $this->f_PrecioVentaIGV;
    }

    /* Establece el valor del campo MontoDescuento */
    public function setMontoDescuento( $f_MontoDescuento )
    {
        $this->f_MontoDescuento = $f_MontoDescuento;
    }

    /* Obtiene el valor del campo MontoDescuento */
    public function getMontoDescuento()
    {
        return $this->f_MontoDescuento;
    }

    /* Establece el valor del campo PorcentajeDescuento */
    public function setPorcentajeDescuento( $f_PorcentajeDescuento )
    {
        $this->f_PorcentajeDescuento = $f_PorcentajeDescuento;
    }

    /* Obtiene el valor del campo PorcentajeDescuento */
    public function getPorcentajeDescuento()
    {
        return $this->f_PorcentajeDescuento;
    }

    /* Establece el valor del campo DescuentoFlag */
    public function setDescuentoFlag( $s_DescuentoFlag )
    {
        $this->s_DescuentoFlag = $s_DescuentoFlag;
    }

    /* Obtiene el valor del campo DescuentoFlag */
    public function getDescuentoFlag()
    {
        return $this->s_DescuentoFlag;
    }

    /* Establece el valor del campo FechaCreacion */
    public function setFechaCreacion( $d_FechaCreacion )
    {
        $this->d_FechaCreacion = $d_FechaCreacion;
    }

    /* Obtiene el valor del campo FechaCreacion */
    public function getFechaCreacion()
    {
        return $this->d_FechaCreacion;
    }

    /* Establece el valor del campo UsuarioCreacion */
    public function setUsuarioCreacion( $s_UsuarioCreacion )
    {
        $this->s_UsuarioCreacion = $s_UsuarioCreacion;
    }

    /* Obtiene el valor del campo UsuarioCreacion */
    public function getUsuarioCreacion()
    {
        return $this->s_UsuarioCreacion;
    }

    /* Establece el valor del campo FechaModificacion */
    public function setFechaModificacion( $d_FechaModificacion )
    {
        $this->d_FechaModificacion = $d_FechaModificacion;
    }

    /* Obtiene el valor del campo FechaModificacion */
    public function getFechaModificacion()
    {
        return $this->d_FechaModificacion;
    }

    /* Establece el valor del campo UsuarioModificacion */
    public function setUsuarioModificacion( $s_UsuarioModificacion )
    {
        $this->s_UsuarioModificacion = $s_UsuarioModificacion;
    }

    /* Obtiene el valor del campo UsuarioModificacion */
    public function getUsuarioModificacion()
    {
        return $this->s_UsuarioModificacion;
    }

    public function getJsonSerialize()
    {
        return 
        [
            'IdListaPreciDet' => $this->getIdListaPreciDet(),
            'IdListaPreciCab' => $this->getIdListaPreciCab(),
            'IdCompania' => $this->getIdCompania(),
            'IdSucursal' => $this->getIdSucursal(),
            'IdItem' => $this->getIdItem(),
            'IdTipoLista' => $this->getIdTipoLista(),
            'IdRango' => $this->getIdRango(),
            'IdRangoDetalle' => $this->getIdRangoDetalle(),
            'IdTipoPrecio' => $this->getIdTipoPrecio(),
            'FechaInicio' => $this->getFechaInicio(),
            'FechaFin' => $this->getFechaFin(),
            'Estado' => $this->getEstado(),
            'PrecioCosto' => $this->getPrecioCosto(),
            'PrecioCostoIGV' => $this->getPrecioCostoIGV(),
            'PorcentajeUtilidad' => $this->getPorcentajeUtilidad(),
            'AfectoIGV' => $this->getAfectoIGV(),
            'PrecioVenta' => $this->getPrecioVenta(),
            'MontoIGV' => $this->getMontoIGV(),
            'PrecioVentaIGV' => $this->getPrecioVentaIGV(),
            'MontoDescuento' => $this->getMontoDescuento(),
            'PorcentajeDescuento' => $this->getPorcentajeDescuento(),
            'DescuentoFlag' => $this->getDescuentoFlag(),
            'FechaCreacion' => $this->getFechaCreacion(),
            'UsuarioCreacion' => $this->getUsuarioCreacion(),
            'FechaModificacion' => $this->getFechaModificacion(),
            'UsuarioModificacion' => $this->getUsuarioModificacion(),
        ];
    }

    public function toArray()
    {
        return $this->processArray( get_object_vars( $this ) ); 
    }

    private function processArray( $array )
    {
        foreach( $array as $key => $value ) 
        {
            if ( is_object( $value ) )
            {
                $array[$key] = $value->toArray();
            }
            if ( is_array( $value ) ) 
            {
                $array[$key] = $this->processArray( $value );
            }
        }
        return $array;
    }

    public function __toString()
    {
        return json_encode( $this->toArray() ); 
    }

    /* Recupera un objeto MST_ListaPrecioDetalleBN desde un RecordSet */
    public static function retrieveByRs( $o_MST_ListaPrecioDetalleRs )
    {
        $o_MST_ListaPrecioDetalleBN = new MST_ListaPrecioDetalleBN();
        $o_MST_ListaPrecioDetalleBN->setIdListaPreciDet( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdListaPreciDet" ] );
        $o_MST_ListaPrecioDetalleBN->setIdListaPreciCab( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdListaPreciCab" ] );
        $o_MST_ListaPrecioDetalleBN->setIdCompania( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdCompania" ] );
        $o_MST_ListaPrecioDetalleBN->setIdSucursal( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdSucursal" ] );
        $o_MST_ListaPrecioDetalleBN->setIdItem( $o_MST_ListaPrecioDetalleRs[ "IdItem" ] );
        $o_MST_ListaPrecioDetalleBN->setIdTipoLista( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdTipoLista" ] );
        $o_MST_ListaPrecioDetalleBN->setIdRango( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdRango" ] );
        $o_MST_ListaPrecioDetalleBN->setIdRangoDetalle( ( integer ) $o_MST_ListaPrecioDetalleRs[ "IdRangoDetalle" ] );
        $o_MST_ListaPrecioDetalleBN->setIdTipoPrecio( $o_MST_ListaPrecioDetalleRs[ "IdTipoPrecio" ] );
        $o_MST_ListaPrecioDetalleBN->setFechaInicio( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleRs[ "FechaInicio" ], "Y-m-d" ) );
        $o_MST_ListaPrecioDetalleBN->setFechaFin( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleRs[ "FechaFin" ], "Y-m-d" ) );
        $o_MST_ListaPrecioDetalleBN->setEstado( $o_MST_ListaPrecioDetalleRs[ "Estado" ] );
        $o_MST_ListaPrecioDetalleBN->setPrecioCosto( ( float ) $o_MST_ListaPrecioDetalleRs[ "PrecioCosto" ] );
        $o_MST_ListaPrecioDetalleBN->setPrecioCostoIGV( ( float ) $o_MST_ListaPrecioDetalleRs[ "PrecioCostoIGV" ] );
        $o_MST_ListaPrecioDetalleBN->setPorcentajeUtilidad( ( float ) $o_MST_ListaPrecioDetalleRs[ "PorcentajeUtilidad" ] );
        $o_MST_ListaPrecioDetalleBN->setAfectoIGV( ( integer ) $o_MST_ListaPrecioDetalleRs[ "AfectoIGV" ] );
        $o_MST_ListaPrecioDetalleBN->setPrecioVenta( ( float ) $o_MST_ListaPrecioDetalleRs[ "PrecioVenta" ] );
        $o_MST_ListaPrecioDetalleBN->setMontoIGV( ( float ) $o_MST_ListaPrecioDetalleRs[ "MontoIGV" ] );
        $o_MST_ListaPrecioDetalleBN->setPrecioVentaIGV( ( float ) $o_MST_ListaPrecioDetalleRs[ "PrecioVentaIGV" ] );
        $o_MST_ListaPrecioDetalleBN->setMontoDescuento( ( float ) $o_MST_ListaPrecioDetalleRs[ "MontoDescuento" ] );
        $o_MST_ListaPrecioDetalleBN->setPorcentajeDescuento( ( float ) $o_MST_ListaPrecioDetalleRs[ "PorcentajeDescuento" ] );
        $o_MST_ListaPrecioDetalleBN->setDescuentoFlag( $o_MST_ListaPrecioDetalleRs[ "DescuentoFlag" ] );
        $o_MST_ListaPrecioDetalleBN->setFechaCreacion( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleRs[ "FechaCreacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ListaPrecioDetalleBN->setUsuarioCreacion( $o_MST_ListaPrecioDetalleRs[ "UsuarioCreacion" ] );
        $o_MST_ListaPrecioDetalleBN->setFechaModificacion( utilTimestamp::getTimestamp( $o_MST_ListaPrecioDetalleRs[ "FechaModificacion" ], "Y-m-d H:i:s" ) );
        $o_MST_ListaPrecioDetalleBN->setUsuarioModificacion( $o_MST_ListaPrecioDetalleRs[ "UsuarioModificacion" ] );
        return $o_MST_ListaPrecioDetalleBN;
    }
}
?>